import React, { useContext, useEffect, useMemo, useState } from 'react'
import { Input, Select, message } from 'antd'
import { LoadTableFields, ReloadTableFields } from '../../../../../apis/process'

const FieldNames = (props) => {

  let fields = window.sessionStorage.getItem('designerRef') || []
  const { value, onChange, addons } = props
  const { tableNameParent, name } = addons.formData
  const [fieldName, setFieldName] = useState([])

  const options = useMemo(() => {
    return fieldName.filter(v => !fields.includes(v.name))
  }, [fieldName])

  const selectChange = (value) => {
    if (name !== '关联表单') {
      addons.setValueByPath('title', value)
    } else {
      addons.setValueByPath('titleShow', value)
    }
    onChange(value)
  }

  const onFocus = async () => {
    if (!tableNameParent) {
      return message.info('缺少表名!')
    }
    const { data } = await ReloadTableFields({ tableName: tableNameParent })
    if (Array.isArray(data.root)) {
      setFieldName(data.root)
    }
  }

  useEffect(() => {
    if (value && value.includes('#/')) {
      let array = value.split('/')
      if (array.length === 3) {
        onChange(array[2])
      } else if (array.length === 2) {
        onChange(array[1])
      }
    }
  }, [value])

  return (
    <Select
      onFocus={onFocus}
      onChange={selectChange}
      style={{ width: '100%' }}
      showSearch
      optionFilterProp='children'
      value={value}
      fieldNames={{ label: 'name', value: 'name' }}
      options={options}
    >
      {/* {
        options.map(v => {
          return (
            <Select.Option key={v.name} value={v.name}>
              <div>
                <span>{v.name}</span>
                 <span>{v.check ? '已选': '未选'}</span> 
              </div>
            </Select.Option>
          )
        })
      } */}
    </Select>
  )
}

export default FieldNames